#!/usr/bin/php4 -q
<?

/*

aEGiS PHP nano web server
=========================

Copyright (C) 2000-2001 Vincent Negrier aka. sIX <six@aegis-corp.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

define(VERSION, "1.0.3");

// Configuration

define(LISTEN_ADDR, "0.0.0.0");		// Listen on all interfaces
define(LISTEN_DEFAULT_PORT, 80);
define(LISTEN_QUEUE, 20);			// Queue up to 20 connections

define(DEFAULT_INDEX, "index.html");

define(HTTP_VERSION, "HTTP/1.0");

$HTTP_HEADERS=array	(	200 => "200 OK",
						403 => "403 Forbiden",
						404 => "404 Not Found"	);

// Functions

function techo($s) {

	echo date("Ymd-Hi")." - $s\n";
	flush();

}

function errexit($s) {

	techo("Error: ".$s);
	exit;

}

// Begin

set_time_limit(0);

techo("aEGiS PHP nano web server v".VERSION." (c)2002 by sIX / aEGiS");

$port=(int)$argv[1]?(int)$argv[1]:LISTEN_DEFAULT_PORT;

if (($sock = @socket_create(AF_INET, SOCK_STREAM, 0))<0) errexit("socket() failed: reason: ".socket_strerror($sock));
if (($ret = @socket_bind($sock, LISTEN_ADDR, $port))<0) errexit("bind() failed: reason: ".socket_strerror($ret));
if (($ret = @socket_listen($sock, LISTEN_QUEUE))<0) errexit("listen() failed: reason: ".socket_strerror($ret));

$run=1;

techo("running and accepting connections on port ".$port);

while ($run) {

	if (($msgsock = @socket_accept($sock)) < 0) {

		techo("accept_connect() failed: reason: ".socket_strerror($msgsock));
		sleep(10);

	}

	$remote_ip="";
	$remote_port=0;
	@socket_getpeername($msgsock, &$remote_ip, &$remote_port);

//	Uncomment for reverse dns query
//	if (!$remote_host=trim(`host $remote_ip |grep "Name:" |cut -c7-`)) $remote_host="unresolved";

	$cnx=true;
	unset($cmds);

	while ($cnx) {

		$buf=@socket_read($msgsock, 2048);
        $cmds.=$buf;

//		$sst=socket_get_status($msgsock);
//		if ($sst["timed_out"] || $sst["blocked"] || $sst["eof"]) $cnx=false;

		if ($cnx) {

			$tmp_arr=explode("\n",$cmds);

			if (trim($tmp_arr[count($tmp_arr)-1])=="" && trim($tmp_arr[count($tmp_arr)-2])=="") {

				$htreq=explode(" ", trim($tmp_arr[0]));
				$http_action=strtoupper($htreq[0]);

				$out_headers="";
				$out_content="";
				$out_contenttype="";
				$rq_err=0;

				switch ($http_action) {

					case "GET":
					case "POST":

					$complete_path=$http_uri=urldecode($htreq[1]);
					while ($http_uri[0]=="/") $http_uri=substr($http_uri, 1);
					$http_uri=str_replace("../", "", $http_uri);
					$http_protocol=$htreq[2];

					$rq_file=pathinfo($http_uri);

					if (!$rq_file["basename"]) {
						
						$http_uri=$rq_file["dirname"]."/".DEFAULT_INDEX;
						$rq_file=pathinfo($http_uri);
						while ($http_uri[0]=="/") $http_uri=substr($http_uri, 1);
						$http_uri=str_replace("../", "", $http_uri);

					}

					if (!is_dir($rq_file["dirname"])) $rq_err=404;
					else if (!@is_file($http_uri) && !@is_link($http_uri)) $rq_err=404;
					else if (!is_readable($http_uri)) $rq_err=403;
					else {

						$rq_err=200;
						
						$f=fopen($http_uri, "r");
						$file_content=fread($f, filesize($http_uri));
						fclose($f);

						switch ($rq_file["extension"]) {

							case "gif":
							$out_contenttype="image/gif";
							break;

							case "jpg":
							case "jpeg":
							$out_contenttype="image/jpeg";
							break;

							case "png":
							$out_contenttype="image/png";
							break;

							case "tgz":
							$out_contenttype="application/x-gtar";
							break;
							
							case "htm":
							case "html":
							$out_contenttype="text/html";
							break;

							default:
							$out_contenttype="text/plain";
						
						}

						if (!$out_content) $out_content=$file_content;

					}

					break;

					case "HEAD":

					$rq_err=200;
					$out_contenttype="text/html";
					
					break;

				}

				if ($rq_err!=200) {
					
					$out_contenttype="text/html";
					$out_content="<html><head><title>".$HTTP_HEADERS[$rq_err]."</title></head><body><h1>".$HTTP_HEADERS[$rq_err]."</h1></body></html>";
				
				}
				
				$out_headers=HTTP_VERSION." ".$HTTP_HEADERS[$rq_err]."\n";
				$out_headers.="Content-type: ".$out_contenttype."\n";
				$out_headers.="Connection: close\n";
				$out_headers.="Server: aEGiS nanoweb ".VERSION." (PHP ".phpversion().")";

				$msg=$out_headers."\n".($out_content?"\n".$out_content:"");
				
				techo("hit (".$http_action." ".$complete_path.") by (".$remote_ip.")");
				socket_write($msgsock, &$msg, strlen($msg));

				$cnx=false;

			}

		}

//		usleep(5000);

	}

	socket_close($msgsock);

}

socket_close ($sock);

techo("daemon stopped");
echo "\n";

?>